.686
.model flat, stdcall
option casemap :none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

DATA_SIZE	equ	04000h	; 64KB of data (16K doublewords)

JJ      equ     10            ; lag 1
KK      equ     17            ; lag 2, size of circular buffer
R1      equ     19            ; rotate count
R2      equ     27            ; rotate count

M_WBRandom2L MACRO
	
local fred
	mov eax,[last_value]
	test eax,eax
	je @F
	xor edx,edx
	mov [last_value],edx
	jmp fred
	
@@:
	MOV EBX, [p1]       ; ring buffer pointers
	MOV ECX, [p2]       ; ring buffer pointer
	MOV EDX, [randbuf][EBX]
	MOV EAX, [randbuf][EBX+4]       
	ROL EDX, R1                  ; rotate bits
	ROL EAX, R2
	ADD EDX, [randbuf][ECX]      ; add two dwords
	ADD EAX, [randbuf][ECX+4]
	MOV [randbuf][EBX], EAX      ; save in swapped order
	MOV [randbuf][EBX+4], EDX
	mov ebx,[PtrNext+ebx*4]
	mov ecx,[PtrNext+ecx*4]
	MOV [p1], EBX                ; save updated pointers
	MOV [p2], ECX

	mov [last_value],edx
fred:
ENDM


.data
	filename	DB "ranrot.bin", 0
	buffer		DD 0
	hFile			DD 0
	byteswritten	DD	0

.data

align   16
randp1  DT      1.5           ; used for conversion to float
        DW      0             ; alignment
p1      DD      0             ; pointer in circular buffer
p2      DD      0             ; pointer in circular buffer
randbuf DD      (2*KK) dup(?) ; circular buffer

; Lookup table for M_WRandomL - uses 544 bytes
align 16
PtrNext label dword
	dd 8 dup ((KK-1)*8)
	counter = 0
  	REPEAT ((KK-1)*8)-1
    	dd counter
			counter = counter + 1
   	endm

; Used by M_WRandom2
align 4
	last_value	dd 0

.code
start:

	push 4*DATA_SIZE
	push LMEM_FIXED
	call LocalAlloc
	mov buffer, eax
	
	call WRandomInit
	
	mov esi, DATA_SIZE
	mov edi, buffer
_loop:
	sub esi, 1
	
	M_WBRandom2L
	
	mov [edi+4*esi], eax
	
	cmp esi, 0
	jnz _loop
	
	push NULL
	push FILE_ATTRIBUTE_NORMAL
	push CREATE_ALWAYS
	push NULL
	push 0
	push GENERIC_WRITE
	push offset filename
	call CreateFile
	mov hFile, eax
	
	push NULL
	push offset byteswritten
	push 4*DATA_SIZE
	push buffer
	push hFile
	call WriteFile
	
	push 0
	call ExitProcess
	
WRandomInit PROC seed:DWORD

        MOV     EAX, seed    ; seed
        XOR     ECX, ECX
        ; make random numbers and put them into buffer
R80:    IMUL    EAX, 2891336453
        INC     EAX
        MOV     [randbuf][ECX*4], EAX
        INC     ECX
        CMP     ECX, KK*2
        JB      R80
        FLD1
        FSTP    [randp1]        ; initialize bit 64-79
        MOV     [p1], 0         ; initialize buffer pointers
        MOV     [p2], JJ*8
        CALL    WBRandom           ; prepare first random number
        PUSH    EDI
        MOV     EDI, 30
R90:    CALL    WBRandom
        DEC     EDI
        JNZ     R90
        POP     EDI                                                

        RET
WRandomInit ENDP


WBRandom PROC

        PUSH    EBX
        MOV     EBX, [p1]       ; ring buffer pointers
        MOV     ECX, [p2]       ; ring buffer pointer
        MOV     EDX, [randbuf][EBX]
        MOV     EAX, [randbuf][EBX+4]       
R20:    ROL     EDX, R1                  ; rotate bits
        ROL     EAX, R2
        ADD     EDX, [randbuf][ECX]      ; add two dwords
        ADD     EAX, [randbuf][ECX+4]
        MOV     [randbuf][EBX], EAX      ; save in swapped order
        MOV     [randbuf][EBX+4], EDX
        SUB     EBX, 8                   ; decrement p1
        JNC     SHORT R30
        MOV     EBX, (KK-1)*8            ; wrap around p1
R30:    SUB     ECX, 8                   ; decrement p2
        JNC     SHORT R40
        MOV     ECX, (KK-1)*8            ; wrap around p2
R40:    MOV     [p1], EBX                ; save updated pointers
        MOV     [p2], ECX
        POP     EBX
        RET
        
WBRandom ENDP

end start